// MuleSystrayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MuleSystrayDlg.h"
#include "emule.h"
#include "Scheduler.h"
#include "otherfunctions.h"
#include "emuleDlg.h"
#include "preferences.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Cax2 - new class without context menu
BEGIN_MESSAGE_MAP(CInputBox, CEdit)
    ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()
void CInputBox::OnContextMenu(CWnd* pWnd, CPoint point)
{
	//Cax2 - nothing to see here!
}

/////////////////////////////////////////////////////////////////////////////
// CMuleSystrayDlg dialog

CMuleSystrayDlg::CMuleSystrayDlg(CWnd* pParent, CPoint pt, int iMaxUp, int iMaxDown, float iCurUp, float iCurDown)
	: CDialog(CMuleSystrayDlg::IDD, pParent)
{
	if(iCurDown == UNLIMITED)
		iCurDown = 0;
	if(iCurUp == UNLIMITED)
		iCurUp = 0;

	//{{AFX_DATA_INIT(CMuleSystrayDlg)
	m_nDownSpeedTxt = iMaxDown < iCurDown ? iMaxDown : iCurDown;
	m_nUpSpeedTxt = iMaxUp < iCurUp ? iMaxUp : iCurUp;
	//}}AFX_DATA_INIT

	m_iMaxUp = iMaxUp;
	m_iMaxDown = iMaxDown;
	m_ptInitialPosition = pt;

	m_hUpArrow = NULL;
	m_hDownArrow = NULL;

	m_nExitCode = 0;
	m_bClosingDown = false;
}

CMuleSystrayDlg::~CMuleSystrayDlg()
{
	if(m_hUpArrow)
		DestroyIcon(m_hUpArrow);
	if(m_hDownArrow)
		DestroyIcon(m_hDownArrow);
}

void CMuleSystrayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMuleSystrayDlg)
	DDX_Control(pDX, IDC_TRAYUP, m_ctrlUpArrow);
	DDX_Control(pDX, IDC_TRAYDOWN, m_ctrlDownArrow);
	DDX_Control(pDX, IDC_SIDEBAR, m_ctrlSidebar);
	DDX_Control(pDX, IDC_UPSLD, m_ctrlUpSpeedSld);
	DDX_Control(pDX, IDC_DOWNSLD, m_ctrlDownSpeedSld);
	DDX_Control(pDX, IDC_DOWNTXT, m_DownSpeedInput);
	DDX_Control(pDX, IDC_UPTXT, m_UpSpeedInput);
	DDX_Control(pDX, IDC_MIN_SLD, m_MinSlider);
	DDX_Control(pDX, IDC_MAX_SLD, m_MaxSlider);
	DDX_Control(pDX, IDC_MAX_PING_SLD, m_MaxPingSlider);
	DDX_Control(pDX, IDC_MIN_TXT, m_MinInput);
	DDX_Control(pDX, IDC_MAX_TXT, m_MaxInput);
	DDX_Control(pDX, IDC_MAX_PING_TXT, m_MaxPingInput);
	DDX_Text(pDX, IDC_MAX_PING_TXT, m_MaxPingTxt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMuleSystrayDlg, CDialog)
	//{{AFX_MSG_MAP(CMuleSystrayDlg)
	ON_WM_MOUSEMOVE()
	ON_EN_CHANGE(IDC_DOWNTXT, OnChangeDowntxt)
	ON_EN_CHANGE(IDC_UPTXT, OnChangeUptxt)
	ON_EN_CHANGE(IDC_MIN_TXT, OnChangeMintxt)
	ON_EN_CHANGE(IDC_MAX_TXT, OnChangeMaxtxt)
	ON_EN_CHANGE(IDC_MAX_PING_TXT, OnChangeMaxPingtxt)
	ON_BN_CLICKED(IDC_SS_ON, OnChangeSSOn)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONUP()
	ON_WM_KILLFOCUS()
	ON_WM_SHOWWINDOW()
	ON_WM_CAPTURECHANGED()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CHANGE_SS, OnBnClickedChangeSs)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_DOWNSLD, OnNMCustomdrawDownsld)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMuleSystrayDlg message handlers

void CMuleSystrayDlg::OnMouseMove(UINT nFlags, CPoint point) 
{	
	CWnd *pWnd = ChildWindowFromPoint(point, CWP_SKIPINVISIBLE|CWP_SKIPDISABLED);
	if(pWnd)
	{
		if(pWnd == this || pWnd == &m_ctrlSidebar)			
			SetCapture();			// me, myself and i
		else						 
			ReleaseCapture();		// sweet child of mine
	}
	else
		SetCapture();				// i'm on the outside, i'm looking in ...

	CDialog::OnMouseMove(nFlags, point);
}

BOOL CMuleSystrayDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_bClosingDown = false;

	CRect r;
	CWnd *p;

	m_hUpArrow = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_UP), IMAGE_ICON, 16, 16, 0);
	m_hDownArrow = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_DOWN), IMAGE_ICON, 16, 16, 0);
	m_ctrlUpArrow.SetIcon(m_hUpArrow); 
	m_ctrlDownArrow.SetIcon(m_hDownArrow); 
    		
	bool	bValidFont = false;
	LOGFONT lfStaticFont;

	p = GetDlgItem(IDC_SPEED);
	if(p)
	{
		p->GetFont()->GetLogFont(&lfStaticFont);
		bValidFont = true;
	}

	p = GetDlgItem(IDC_SPEED);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlSpeed.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_SPEED);
		m_ctrlSpeed.m_nBtnID = IDC_SPEED;
		//p->GetWindowText(m_ctrlSpeed.m_strText);
		m_ctrlSpeed.m_strText = GetResString(IDS_TRAYDLG_SPEED);
		
		m_ctrlSpeed.m_bUseIcon = true;
		m_ctrlSpeed.m_sIcon.cx = 16;
		m_ctrlSpeed.m_sIcon.cy = 16;
		m_ctrlSpeed.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_SPEED), IMAGE_ICON, m_ctrlSpeed.m_sIcon.cx, m_ctrlSpeed.m_sIcon.cy, 0);
		m_ctrlSpeed.m_bParentCapture = true;
		if(bValidFont)
		{	
			LOGFONT lfFont = lfStaticFont;
			lfFont.lfWeight += 200;			// make it bold
			m_ctrlSpeed.m_cfFont.CreateFontIndirect(&lfFont);
		}
		
		m_ctrlSpeed.m_bNoHover = true;
	}

	p = GetDlgItem(IDC_TOMAX);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlAllToMax.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_TOMAX);
		m_ctrlAllToMax.m_nBtnID = IDC_TOMAX;
		//p->GetWindowText(m_ctrlAllToMax.m_strText);
		m_ctrlAllToMax.m_strText = GetResString(IDS_PW_UA);

		m_ctrlAllToMax.m_bUseIcon = true;
		m_ctrlAllToMax.m_sIcon.cx = 16;
		m_ctrlAllToMax.m_sIcon.cy = 16;
		m_ctrlAllToMax.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_TOMAX), IMAGE_ICON, m_ctrlAllToMax.m_sIcon.cx, m_ctrlAllToMax.m_sIcon.cy, 0);
		m_ctrlAllToMax.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlAllToMax.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}

	p = GetDlgItem(IDC_TOMIN);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlAllToMin.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_TOMIN);
		m_ctrlAllToMin.m_nBtnID = IDC_TOMIN;
		//p->GetWindowText(m_ctrlAllToMin.m_strText);
		m_ctrlAllToMin.m_strText = GetResString(IDS_PW_PA);

		m_ctrlAllToMin.m_bUseIcon = true;
		m_ctrlAllToMin.m_sIcon.cx = 16;
		m_ctrlAllToMin.m_sIcon.cy = 16;
		m_ctrlAllToMin.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_TOMIN), IMAGE_ICON, m_ctrlAllToMin.m_sIcon.cx, m_ctrlAllToMin.m_sIcon.cy, 0);
		m_ctrlAllToMin.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlAllToMin.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}

	//Pawcio: SS
	p = GetDlgItem(IDC_SS_SPEED);
	if(p)
	{
		p->GetFont()->GetLogFont(&lfStaticFont);
		bValidFont = true;
	}

	p = GetDlgItem(IDC_SS_SPEED);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlSSSpeed.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_SS_SPEED);
		m_ctrlSSSpeed.m_nBtnID = IDC_SPEED;
		m_ctrlSSSpeed.m_strText = (theApp.emuledlg->USSTab ? GetResString(IDS_TRAYDLG_USS_SPEED) : GetResString(IDS_TRAYDLG_DSS_SPEED));
		/*m_ctrlSSSpeed.m_bUseIcon = true;
		m_ctrlSSSpeed.m_sIcon.cx = 16;
		m_ctrlSSSpeed.m_sIcon.cy = 16;*/
		m_ctrlSSSpeed.m_bParentCapture = true;
		if(bValidFont)
		{	
			LOGFONT lfFont = lfStaticFont;
			lfFont.lfWeight += 200;			// make it bold
			m_ctrlSSSpeed.m_cfFont.CreateFontIndirect(&lfFont);
		}
		
		m_ctrlSSSpeed.m_bNoHover = true;
	}
	if((p = GetDlgItem(IDC_CHANGE_SS)) != NULL)
		p->SetWindowText(_T("--->"));
	InitSSDialog();
	//Pawcio: SS

	p = GetDlgItem(IDC_RESTORE);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlRestore.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_RESTORE);
		m_ctrlRestore.m_nBtnID = IDC_RESTORE;
		//p->GetWindowText(m_ctrlRestore.m_strText);
		m_ctrlRestore.m_strText = GetResString(IDS_MAIN_POPUP_RESTORE);

		m_ctrlRestore.m_bUseIcon = true;
		m_ctrlRestore.m_sIcon.cx = 16;
		m_ctrlRestore.m_sIcon.cy = 16;
		m_ctrlRestore.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_RESTORE), IMAGE_ICON, m_ctrlRestore.m_sIcon.cx, m_ctrlRestore.m_sIcon.cy, 0);
		m_ctrlRestore.m_bParentCapture = true;
		if(bValidFont)
		{	
			LOGFONT lfFont = lfStaticFont;
			lfFont.lfWeight += 200;			// make it bold
			m_ctrlRestore.m_cfFont.CreateFontIndirect(&lfFont);
		}	
	}
	
	p = GetDlgItem(IDC_CONNECT);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlConnect.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_CONNECT);
		m_ctrlConnect.m_nBtnID = IDC_CONNECT;
		//p->GetWindowText(m_ctrlConnect.m_strText);
		m_ctrlConnect.m_strText = GetResString(IDS_CONNECTTOANYSERVER);

		m_ctrlConnect.m_bUseIcon = true;
		m_ctrlConnect.m_sIcon.cx = 16;
		m_ctrlConnect.m_sIcon.cy = 16;
		m_ctrlConnect.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_CONNECT), IMAGE_ICON, m_ctrlConnect.m_sIcon.cx, m_ctrlConnect.m_sIcon.cy, 0);
		m_ctrlConnect.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlConnect.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}

	p = GetDlgItem(IDC_DISCONNECT);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlDisconnect.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_DISCONNECT);
		m_ctrlDisconnect.m_nBtnID = IDC_DISCONNECT;
		//p->GetWindowText(m_ctrlDisconnect.m_strText);
		m_ctrlDisconnect.m_strText = GetResString(IDS_MAIN_BTN_DISCONNECT);
		m_ctrlDisconnect.m_strText.Remove('&');

		m_ctrlDisconnect.m_bUseIcon = true;
		m_ctrlDisconnect.m_sIcon.cx = 16;
		m_ctrlDisconnect.m_sIcon.cy = 16;
		m_ctrlDisconnect.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TRAY_DISCONNECT), IMAGE_ICON, m_ctrlDisconnect.m_sIcon.cx, m_ctrlDisconnect.m_sIcon.cy, 0);
		m_ctrlDisconnect.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlDisconnect.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}

	p = GetDlgItem(IDC_PREFERENCES);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlPreferences.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_PREFERENCES);
		m_ctrlPreferences.m_nBtnID = IDC_PREFERENCES;
		//p->GetWindowText(m_ctrlPreferences.m_strText);
		m_ctrlPreferences.m_strText = GetResString(IDS_EM_PREFS);
		m_ctrlPreferences.m_strText.Remove('&');

		m_ctrlPreferences.m_bUseIcon = true;
		m_ctrlPreferences.m_sIcon.cx = 16;
		m_ctrlPreferences.m_sIcon.cy = 16;
		m_ctrlPreferences.m_hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), _T("PREF_GENERAL"), IMAGE_ICON, m_ctrlPreferences.m_sIcon.cx, m_ctrlPreferences.m_sIcon.cy, 0);
		m_ctrlPreferences.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlPreferences.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}

	// [ionix] - TBH: minimule
	p = GetDlgItem(IDC_MINIMULE);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlMiniMule.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_MINIMULE);
		m_ctrlMiniMule.m_nBtnID = IDC_MINIMULE;
		m_ctrlMiniMule.m_strText = "Mini-Mule";
		m_ctrlMiniMule.m_strText.Remove('&');

		m_ctrlMiniMule.m_bUseIcon = true;
		m_ctrlMiniMule.m_sIcon.cx = 16;
		m_ctrlMiniMule.m_sIcon.cy = 16;
		m_ctrlMiniMule.m_hIcon = theApp.LoadIcon(_T("MINIMULE"), m_ctrlMiniMule.m_sIcon.cx, m_ctrlMiniMule.m_sIcon.cy);
		m_ctrlMiniMule.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlMiniMule.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}
	// [ionix] - TBH: minimule

	p = GetDlgItem(IDC_EXIT_TRAY);
	if(p)
	{
		p->GetWindowRect(r);
		ScreenToClient(r);
		m_ctrlExit.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, this, IDC_EXIT);
		m_ctrlExit.m_nBtnID = IDC_EXIT;
		//p->GetWindowText(m_ctrlExit.m_strText);
		m_ctrlExit.m_strText = GetResString(IDS_EXIT);
		m_ctrlExit.m_strText.Remove(_T('&'));

		m_ctrlExit.m_bUseIcon = true;
		m_ctrlExit.m_sIcon.cx = 16;
		m_ctrlExit.m_sIcon.cy = 16;
		m_ctrlExit.m_hIcon = theApp.LoadIcon(_T("TRAY_EXIT"), m_ctrlExit.m_sIcon.cx, m_ctrlExit.m_sIcon.cy);
		m_ctrlExit.m_bParentCapture = true;
		if(bValidFont)
			m_ctrlExit.m_cfFont.CreateFontIndirect(&lfStaticFont);
	}

	if((p = GetDlgItem(IDC_DOWNLBL)) != NULL)
		p->SetWindowText(GetResString(IDS_PW_CON_DOWNLBL));
	if((p = GetDlgItem(IDC_UPLBL)) != NULL)
		p->SetWindowText(GetResString(IDS_PW_CON_UPLBL));
	if((p = GetDlgItem(IDC_DOWNKB)) != NULL)
		p->SetWindowText(GetResString(IDS_KBYTESEC));
	if((p = GetDlgItem(IDC_UPKB)) != NULL)
		p->SetWindowText(GetResString(IDS_KBYTESEC));

	m_ctrlDownSpeedSld.SetRange(0,(m_iMaxDown <= 10 ? m_iMaxDown*10 : m_iMaxDown), true);
	m_ctrlDownSpeedSld.SetPos((m_iMaxDown <= 10 ? m_nDownSpeedTxt*10 : m_nDownSpeedTxt));

	m_ctrlUpSpeedSld.SetRange((m_iMaxUp <= 10 ? 10 : 1),(m_iMaxUp <= 10 ? m_iMaxUp*10 : m_iMaxUp), true);
	m_ctrlUpSpeedSld.SetPos((m_iMaxUp <= 10 ? m_nUpSpeedTxt*10 : m_nUpSpeedTxt));

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	CString strBuffer;
	if(thePrefs.GetMaxDownload() == UNLIMITED){
		// Maybe a string "unlimited" would be better
		strBuffer.Format(_T("%.1f"), 0.0f); // To have ',' or '.' (see french)
		GetDlgItem(IDC_DOWNTXT)->SetWindowText(strBuffer);
	}
	else {
		strBuffer.Format(_T("%.1f"), thePrefs.GetMaxDownload());
		GetDlgItem(IDC_DOWNTXT)->SetWindowText(strBuffer);
	}
	
	strBuffer.Format(_T("%.1f"), thePrefs.GetMaxUpload());
	GetDlgItem(IDC_UPTXT)->SetWindowText(strBuffer);
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	CFont Font;
	Font.CreateFont(-16,0,900,0,700,0,0,0,0,3,2,1,34,_T("Tahoma"));

	UINT winver = thePrefs.GetWindowsVersion();
	if(winver == _WINVER_95_ || winver == _WINVER_NT4_)
	{
		m_ctrlSidebar.SetColors(GetSysColor(COLOR_CAPTIONTEXT), 
									GetSysColor(COLOR_ACTIVECAPTION), 
										GetSysColor(COLOR_ACTIVECAPTION));
	}
	else
	{
		m_ctrlSidebar.SetColors(GetSysColor(COLOR_CAPTIONTEXT), 
									GetSysColor(COLOR_ACTIVECAPTION), 
										GetSysColor(27));	//COLOR_GRADIENTACTIVECAPTION
	}

	m_ctrlSidebar.SetHorizontal(false);
	m_ctrlSidebar.SetFont(&Font);
	m_ctrlSidebar.SetWindowText(_T("eMule ") + theApp.m_strCurVersionLong);
	
	CRect rDesktop;
	CWnd *pDesktopWnd = GetDesktopWindow();
	pDesktopWnd->GetClientRect(rDesktop);
	
	CPoint pt = m_ptInitialPosition;
	pDesktopWnd->ScreenToClient(&pt);
	int xpos, ypos;

	GetWindowRect(r);
	if(m_ptInitialPosition.x + r.Width() < rDesktop.right)
		xpos = pt.x;
	else
		xpos = pt.x - r.Width();
	if(m_ptInitialPosition.y - r.Height() < rDesktop.top)
		ypos = pt.y;
	else
		ypos = pt.y - r.Height();
	
	MoveWindow(xpos, ypos, r.Width(), r.Height());
	SetCapture();

	changed=false;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMuleSystrayDlg::InitSSDialog(){
	//Pawcio: SS Tray
	CWnd *p;
	if (theApp.emuledlg->USSTab){
		m_MinTxt = thePrefs.GetMinBCUpload();
		m_MaxTxt = thePrefs.GetMaxBCUpload();
		if (thePrefs.IsManualUpMaxPing())
			m_MaxPingTxt = thePrefs.GetBasePingUp();
		else
			m_MaxPingTxt = thePrefs.GetUSSSliderPos();
		bool USSOn=thePrefs.IsUSSEnabled();
		if (USSOn)
			CheckDlgButton(IDC_SS_ON,1);
		else
			CheckDlgButton(IDC_SS_ON,0);
		CString strBuffer;
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		p = GetDlgItem(IDC_MIN_TXT);
		if (p){
			strBuffer.Format(_T("%.1f"), thePrefs.GetMinBCUpload());
			p->SetWindowText(strBuffer);
		}
		
		p = GetDlgItem(IDC_MAX_TXT);
		if (p){
			if(thePrefs.IsAutoMaxUpload()){
				p->SetWindowText(_T("Auto")); 
			}
			else {
				strBuffer.Format(_T("%.1f"), thePrefs.GetMaxBCUpload());
				GetDlgItem(IDC_MAX_TXT)->SetWindowText(strBuffer);
			}
		}
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

		m_MinSlider.SetRange((m_iMaxUp <= 10 ? 10 : 1),(m_iMaxUp <= 10 ? m_iMaxUp*10 : m_iMaxUp),true);
		m_MinSlider.SetPos((m_iMaxUp <= 10 ? m_MinTxt*10 : m_MinTxt));

		m_MaxSlider.SetRange(0,(m_iMaxUp <= 10 ? m_iMaxUp*10 : m_iMaxUp),true);
		m_MaxSlider.SetPos((m_iMaxUp <= 10 ? m_MaxTxt*10 : m_MaxTxt));

		if (thePrefs.IsManualUpMaxPing()){
			m_MaxPingSlider.SetRange(1,250,true);
			m_MaxPingSlider.SetPos(m_MaxPingTxt/10);
		}
		else {
			m_MaxPingSlider.SetRange(1,24,true);
			m_MaxPingSlider.SetPos(m_MaxPingTxt);
		}
		if((p = GetDlgItem(IDC_MIN_S)) != NULL)
			p->SetWindowText(GetResString(IDS_TRAYDLG_MINUP));
		if((p = GetDlgItem(IDC_MAX_S)) != NULL)
			p->SetWindowText(GetResString(IDS_TRAYDLG_MAXUP));
		if((p = GetDlgItem(IDC_MAX_PING_S)) != NULL){
			if (thePrefs.IsManualUpMaxPing()){
				p->SetWindowText(GetResString(IDS_TRAYDLG_PING));
				strBuffer.Format(_T("%d"),m_MaxPingTxt);
				GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(strBuffer);
				GetDlgItem(IDC_MAX_PING_MS)->SetWindowText(_T("ms"));
			}
			else {
				p->SetWindowText(GetResString(IDS_TRAYDLG_SURF));
				if (m_MaxPingTxt <= 8)
					GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_F));
				else if (m_MaxPingTxt <= 16)
					GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_N));
				else
					GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_S));
				GetDlgItem(IDC_MAX_PING_MS)->SetWindowText(_T(""));
			}
		}
		m_ctrlSSSpeed.m_strText=GetResString(IDS_TRAYDLG_USS_SPEED);
		m_ctrlSSSpeed.Invalidate();
	}
	else {
		m_MinTxt = thePrefs.GetMinBCDownload();
		m_MaxTxt = thePrefs.GetMaxBCDownload();
		if (thePrefs.IsManualDownMaxPing())
			m_MaxPingTxt = thePrefs.GetBasePingDown();
		else
			m_MaxPingTxt = thePrefs.GetDSSSliderPos();
		bool DSSOn=thePrefs.IsDSSEnabled();
		if (DSSOn)
			CheckDlgButton(IDC_SS_ON,1);
		else
			CheckDlgButton(IDC_SS_ON,0);
		CString strBuffer;
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		p = GetDlgItem(IDC_MIN_TXT);
		if (p){
			strBuffer.Format(_T("%.1f"), thePrefs.GetMinBCDownload());
			p->SetWindowText(strBuffer);
		}
		
		p = GetDlgItem(IDC_MAX_TXT);
		if (p){
			if(thePrefs.IsAutoMaxDownload()){
				p->SetWindowText(_T("Auto")); 
			}
			else {
				strBuffer.Format(_T("%.1f"), thePrefs.GetMaxBCDownload());
				GetDlgItem(IDC_MAX_TXT)->SetWindowText(strBuffer);
			}
		}
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

		m_MinSlider.SetRange((m_iMaxDown <= 10 ? 10 : 1),(m_iMaxDown <= 10 ? m_iMaxDown*10 : m_iMaxDown),true);
		m_MinSlider.SetPos((m_iMaxDown <= 10 ? m_MinTxt*10 : m_MinTxt));

		m_MaxSlider.SetRange(0,(m_iMaxDown <= 10 ? m_iMaxDown*10 : m_iMaxDown),true);
		m_MaxSlider.SetPos((m_iMaxDown <= 10 ? m_MaxTxt*10 : m_MaxTxt));

		if (thePrefs.IsManualDownMaxPing()){
			m_MaxPingSlider.SetRange(1,350,true);
			m_MaxPingSlider.SetPos(m_MaxPingTxt/10);
		}
		else {
			m_MaxPingSlider.SetRange(1,24,true);
			m_MaxPingSlider.SetPos(m_MaxPingTxt);
		}
		if((p = GetDlgItem(IDC_MIN_S)) != NULL)
			p->SetWindowText(GetResString(IDS_TRAYDLG_MINDOWN));
		if((p = GetDlgItem(IDC_MAX_S)) != NULL)
			p->SetWindowText(GetResString(IDS_TRAYDLG_MAXDOWN));
		if((p = GetDlgItem(IDC_MAX_PING_S)) != NULL){
			if (thePrefs.IsManualDownMaxPing()){
				p->SetWindowText(GetResString(IDS_TRAYDLG_PING));
				strBuffer.Format(_T("%d"),m_MaxPingTxt);
				GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(strBuffer);
				GetDlgItem(IDC_MAX_PING_MS)->SetWindowText(_T("ms"));
			}
			else {
				p->SetWindowText(GetResString(IDS_TRAYDLG_SURF));
				if (m_MaxPingTxt <= 8)
					GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_F));
				else if (m_MaxPingTxt <= 16)
					GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_N));
				else
					GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_S));
				GetDlgItem(IDC_MAX_PING_MS)->SetWindowText(_T(""));
			}
		}
		m_ctrlSSSpeed.m_strText=GetResString(IDS_TRAYDLG_DSS_SPEED);
		m_ctrlSSSpeed.Invalidate();
	}
	
	OnChangeSSOn();

	if ((p = GetDlgItem(IDC_MIN_KB)) != NULL)
		p->SetWindowText(GetResString(IDS_KBYTESEC));
	if ((p = GetDlgItem(IDC_MAX_KB)) != NULL)
		p->SetWindowText(GetResString(IDS_KBYTESEC));
	//Pawcio: SS Tray
}

void CMuleSystrayDlg::OnChangeDowntxt() 
{
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	// Download rate
	CString buffer;
	if(GetDlgItem(IDC_DOWNTXT)->GetWindowTextLength())
	{
		GetDlgItem(IDC_DOWNTXT)->GetWindowText(buffer);
		m_nDownSpeedTxt = _tstof(buffer);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	if(m_nDownSpeedTxt < 1.0f)
		m_nDownSpeedTxt = 0.0f;
	m_ctrlDownSpeedSld.SetPos((m_iMaxDown <= 10 ? (uint32)(m_nDownSpeedTxt*10.0f) : (uint32)m_nDownSpeedTxt));
	thePrefs.SetMaxDownload(m_nDownSpeedTxt != 0.0f ? m_nDownSpeedTxt : UNLIMITED);
	changed=true;
}

void CMuleSystrayDlg::OnChangeUptxt() 
{
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	// Upload rate
	CString buffer;
	if(GetDlgItem(IDC_UPTXT)->GetWindowTextLength())
	{
		GetDlgItem(IDC_UPTXT)->GetWindowText(buffer);
		m_nUpSpeedTxt = _tstof(buffer);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(m_nUpSpeedTxt < 1.0f)
		m_nUpSpeedTxt = 1.0f;

	m_ctrlUpSpeedSld.SetPos((m_iMaxUp <= 10 ? (uint32)(m_nUpSpeedTxt*10.0f) : (uint32)m_nUpSpeedTxt));
	thePrefs.SetMaxUpload(m_nUpSpeedTxt);
	changed=true;
}

void CMuleSystrayDlg::OnChangeSSOn() 
{
	bool val;
	if (theApp.emuledlg->USSTab)
		thePrefs.SetUSSEnabled(val=IsDlgButtonChecked(IDC_SS_ON)!=0);
	else
		thePrefs.SetDSSEnabled(val=IsDlgButtonChecked(IDC_SS_ON)!=0);
	if(val){	
		GetDlgItem(IDC_MIN_S)->EnableWindow(TRUE);
		GetDlgItem(IDC_MIN_SLD)->EnableWindow(TRUE);
		GetDlgItem(IDC_MIN_TXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MIN_KB)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_S)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_SLD)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_TXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_KB)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_PING_S)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_PING_SLD)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_PING_TXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MAX_PING_MS)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_MIN_S)->EnableWindow(FALSE);
		GetDlgItem(IDC_MIN_SLD)->EnableWindow(FALSE);
		GetDlgItem(IDC_MIN_TXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MIN_KB)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_S)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_SLD)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_TXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_KB)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_PING_S)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_PING_SLD)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_PING_TXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MAX_PING_MS)->EnableWindow(FALSE);
	}
	changed=true;
}

void CMuleSystrayDlg::OnChangeMintxt(){
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	CString buffer;
	if(GetDlgItem(IDC_MIN_TXT)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MIN_TXT)->GetWindowText(buffer);
		m_MinTxt = _tstof(buffer);
	}
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if (theApp.emuledlg->USSTab){
		if(m_MinTxt < 1.0f)
			m_MinTxt = 1.0f;
		m_MinSlider.SetPos((m_iMaxUp <= 10 ? (uint32)(m_MinTxt*10.0f) : (uint32)m_MinTxt));
		thePrefs.SetMinBCUpload(m_MinTxt);
	}
	else{
		if(m_MinTxt < 1.0f)
			m_MinTxt = 1.0f;
		m_MinSlider.SetPos((m_iMaxDown <= 10 ? (uint32)(m_MinTxt*10.0f) : (uint32)m_MinTxt));
		thePrefs.SetMinBCDownload(m_MinTxt);
	}
	changed=true;
}

void CMuleSystrayDlg::OnChangeMaxtxt(){
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	CString buffer;
	if(GetDlgItem(IDC_MAX_TXT)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAX_TXT)->GetWindowText(buffer);
		m_MaxTxt = _tstof(buffer);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	if (theApp.emuledlg->USSTab){
		if(m_MaxTxt < 1.0f)
			m_MaxTxt = 0.0f;
		m_MaxSlider.SetPos((m_iMaxUp <= 10 ? m_MaxTxt*10 : m_MaxTxt));
		thePrefs.SetMaxBCUpload(m_MaxTxt);
		if (m_MaxTxt == 0.0f)
			thePrefs.SetAutoMaxUpload(true);
		else
			thePrefs.SetAutoMaxUpload(false);
	}
	else {
		if(m_MaxTxt < 1.0f)
			m_MaxTxt = 0.0f;
		m_MaxSlider.SetPos((m_iMaxDown <= 10 ? m_MaxTxt*10 : m_MaxTxt));
		thePrefs.SetMaxBCDownload(m_MaxTxt);
		if (m_MaxTxt == 0.0f)
			thePrefs.SetAutoMaxDownload(true);
		else
			thePrefs.SetAutoMaxDownload(false);
	}
	changed=true;
}

void CMuleSystrayDlg::OnChangeMaxPingtxt(){
	if (theApp.emuledlg->USSTab){
		if (thePrefs.IsManualUpMaxPing()){
			UpdateData();

			if(m_MaxPingTxt < 1)
				m_MaxPingTxt = 1;
			if(m_MaxPingTxt > 2500)
				m_MaxPingTxt = 2500;
			m_MaxPingSlider.SetPos((m_MaxPingTxt < 10 ? 1 : m_MaxPingTxt/10));
			thePrefs.SetBasePingUp((m_MaxPingTxt < 10 ? 10 : m_MaxPingTxt));

			UpdateData(FALSE);
			changed=true;
		}
	}
	else{
		if (thePrefs.IsManualDownMaxPing()){
			UpdateData();

			if(m_MaxPingTxt < 1)
				m_MaxPingTxt = 1;
			if(m_MaxPingTxt > 3500)
				m_MaxPingTxt = 3500;
			m_MaxPingSlider.SetPos((m_MaxPingTxt < 10 ? 1 : m_MaxPingTxt/10));
			thePrefs.SetBasePingDown((m_MaxPingTxt < 10 ? 10 : m_MaxPingTxt));

			UpdateData(FALSE);
			changed=true;
		}
	}
}


void CMuleSystrayDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(pScrollBar == (CScrollBar*)&m_ctrlDownSpeedSld)
	{
		m_nDownSpeedTxt = m_ctrlDownSpeedSld.GetPos();
		if (m_iMaxDown <= 10)
			m_nDownSpeedTxt/=10.0f;
		if (m_nDownSpeedTxt < 1.0f && m_nDownSpeedTxt > 0.0f)
			m_nDownSpeedTxt = 1.0f;
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		CString strBuffer;
		strBuffer.Format(_T("%.1f"), m_nDownSpeedTxt);
		GetDlgItem(IDC_DOWNTXT)->SetWindowText(strBuffer);
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		thePrefs.SetMaxDownload(m_nDownSpeedTxt != 0.0f ? m_nDownSpeedTxt : UNLIMITED);
	}
	else if(pScrollBar == (CScrollBar*)&m_ctrlUpSpeedSld)
	{
		m_nUpSpeedTxt = m_ctrlUpSpeedSld.GetPos();
		if (m_iMaxUp <= 10)
			m_nUpSpeedTxt/=10.0f;
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		CString strBuffer;
		strBuffer.Format(_T("%.1f"), m_nUpSpeedTxt);
		GetDlgItem(IDC_UPTXT)->SetWindowText(strBuffer);
		//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
		thePrefs.SetMaxUpload(m_nUpSpeedTxt);
	}
	else {
		if (theApp.emuledlg->USSTab){
			if(pScrollBar == (CScrollBar*)&m_MinSlider){
				m_MinTxt = m_MinSlider.GetPos();
				if (m_iMaxUp <= 10)
					m_MinTxt/=10.0f;
				if (m_MinTxt > m_MaxTxt && m_MaxTxt != 0.0f){
					m_MaxTxt=m_MinTxt;
					m_MaxSlider.SetPos((m_iMaxUp<=10 ? m_MaxTxt*10 : m_MaxTxt));
					thePrefs.SetMaxBCUpload(m_MaxTxt);
				}
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				CString strBuffer;
				strBuffer.Format(_T("%.1f"), m_MinTxt);
				GetDlgItem(IDC_MIN_TXT)->SetWindowText(strBuffer);
				if (m_MaxTxt != 0.0f)
					strBuffer.Format(_T("%.1f"), m_MaxTxt);
				else
					strBuffer = _T("Auto");
				GetDlgItem(IDC_MAX_TXT)->SetWindowText(strBuffer);
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				thePrefs.SetMinBCUpload(m_MinTxt);
			}
			else if(pScrollBar == (CScrollBar*)&m_MaxSlider){
				m_MaxTxt = m_MaxSlider.GetPos();
				if (m_iMaxUp <= 10)
					m_MaxTxt/=10.0f;
				if (m_MaxTxt < 1.0f && m_MaxTxt > 0.0f)
					m_MaxTxt = 1.0f;
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				CString strBuffer;
				if (m_MaxTxt != 0.0f)
					strBuffer.Format(_T("%.1f"), m_MaxTxt);
				else
					strBuffer = _T("Auto");
				GetDlgItem(IDC_MAX_TXT)->SetWindowText(strBuffer);
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				thePrefs.SetMaxBCUpload(m_MaxTxt);
				if (m_MaxTxt == 0.0f)
					thePrefs.SetAutoMaxUpload(true);
				else
					thePrefs.SetAutoMaxUpload(false);
			}
			else if(pScrollBar == (CScrollBar*)&m_MaxPingSlider){
				if (thePrefs.IsManualUpMaxPing()){
					m_MaxPingTxt = m_MaxPingSlider.GetPos()*10;
					UpdateData(FALSE);
					thePrefs.SetBasePingUp(m_MaxPingTxt);
				}
				else{
					m_MaxPingTxt = m_MaxPingSlider.GetPos();
					thePrefs.SetUSSSliderPos(m_MaxPingTxt);
					if (m_MaxPingTxt <= 8)
						GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_F));
					else if (m_MaxPingTxt <= 16)
						GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_N));
					else
						GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_S));
				}
			}
		}
		else {
			if(pScrollBar == (CScrollBar*)&m_MinSlider){
				m_MinTxt = m_MinSlider.GetPos();
				if (m_iMaxDown <= 10)
					m_MinTxt/=10.0f;
				if (m_MinTxt > m_MaxTxt && m_MaxTxt != 0.0f){
					m_MaxTxt=m_MinTxt;
					m_MaxSlider.SetPos((m_iMaxDown<=10 ? m_MaxTxt*10 : m_MaxTxt));
					thePrefs.SetMaxBCDownload(m_MaxTxt);
				}
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				CString strBuffer;
				strBuffer.Format(_T("%.1f"), m_MinTxt);
				GetDlgItem(IDC_MIN_TXT)->SetWindowText(strBuffer);
				if (m_MaxTxt != 0.0f)
					strBuffer.Format(_T("%.1f"), m_MaxTxt);
				else
					strBuffer = _T("Auto");
				GetDlgItem(IDC_MAX_TXT)->SetWindowText(strBuffer);
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				thePrefs.SetMinBCDownload(m_MinTxt);
			}
			else if(pScrollBar == (CScrollBar*)&m_MaxSlider){
				m_MaxTxt = m_MaxSlider.GetPos();
				if (m_iMaxDown <= 10)
					m_MaxTxt/=10.0f;
				if (m_MaxTxt < 1.0f && m_MaxTxt > 0.0f)
					m_MaxTxt = 1.0f;
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				CString strBuffer;
				if (m_MaxTxt != 0.0f)
					strBuffer.Format(_T("%.1f"), m_MaxTxt);
				else
					strBuffer = _T("Auto");
				GetDlgItem(IDC_MAX_TXT)->SetWindowText(strBuffer);
				//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
				thePrefs.SetMaxBCDownload(m_MaxTxt);
				if (m_MaxTxt == 0.0f)
					thePrefs.SetAutoMaxDownload(true);
				else
					thePrefs.SetAutoMaxDownload(false);
			}
			else if(pScrollBar == (CScrollBar*)&m_MaxPingSlider){
				if (thePrefs.IsManualDownMaxPing()){
					m_MaxPingTxt = m_MaxPingSlider.GetPos()*10;
					UpdateData(FALSE);
					thePrefs.SetBasePingDown(m_MaxPingTxt);
				}
				else{
					m_MaxPingTxt = m_MaxPingSlider.GetPos();
					thePrefs.SetDSSSliderPos(m_MaxPingTxt);
					if (m_MaxPingTxt <= 8)
						GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_F));
					else if (m_MaxPingTxt <= 16)
						GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_N));
					else
						GetDlgItem(IDC_MAX_PING_TXT)->SetWindowText(GetResString(IDS_TRAYDLG_SURF_S));
				}
			}
		}
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	changed=true;
}

void CMuleSystrayDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture();	
	EndDialog(m_nExitCode);
	m_bClosingDown = true;

	CDialog::OnLButtonUp(nFlags, point);
}

void CMuleSystrayDlg::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);

	if(m_MaxTxt < m_MinTxt && m_MaxTxt!= 0.0f){
		m_MaxTxt = m_MinTxt;
		thePrefs.SetMaxBCUpload(m_MaxTxt);
	}
	
	if (changed) theApp.scheduler->SaveOriginals();

	if(!m_bClosingDown)
	{
		ReleaseCapture();
		EndDialog(m_nExitCode);
		m_bClosingDown = true;
	}
}

void CMuleSystrayDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	if(!bShow && !m_bClosingDown)
	{
		ReleaseCapture();
		EndDialog(m_nExitCode);
		m_bClosingDown = true;
	}

	CDialog::OnShowWindow(bShow, nStatus);
}

void CMuleSystrayDlg::OnCaptureChanged(CWnd *pWnd) 
{
	if(pWnd && pWnd != this && !IsChild(pWnd))
	{
		EndDialog(m_nExitCode);
		m_bClosingDown = true;
	}
	CDialog::OnCaptureChanged(pWnd);
}

BOOL CMuleSystrayDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if(HIWORD(wParam) == BN_CLICKED && LOWORD(wParam) != IDC_SS_ON && LOWORD(wParam)!= IDC_CHANGE_SS)
	{	
		ReleaseCapture();
		m_nExitCode = LOWORD(wParam);
		EndDialog(m_nExitCode);
		m_bClosingDown = true;
	}

	return CDialog::OnCommand(wParam, lParam);
}

void CMuleSystrayDlg::OnBnClickedChangeSs()
{
	theApp.emuledlg->USSTab=!theApp.emuledlg->USSTab;
	InitSSDialog();
}

void CMuleSystrayDlg::OnStnClickedDisconnect()
{
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
}

void CMuleSystrayDlg::OnNMCustomdrawDownsld(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	*pResult = 0;
}
