#pragma once
#include "TreeOptionsCtrlEx.h"

class CPPgTweaks : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgTweaks)

public:
	CPPgTweaks();
	virtual ~CPPgTweaks();

// Dialog Data
	enum { IDD = IDD_PPG_TWEAKS };

	void Localize(void);

protected:
	UINT m_iFileBufferSize;
	UINT m_iQueueSize;
	int m_iMaxConnPerFive;
	int m_iMaxHalfOpen;
	bool m_bConditionalTCPAccept;
	bool m_bAutoTakeEd2kLinks;
	bool m_bVerbose;
	bool m_bDebugSourceExchange;
	bool m_bLogBannedClients;
	bool m_bLogRatingDescReceived;
	bool m_bLogSecureIdent;
	bool m_bLogFilteredIPs;
	bool m_bLogFileSaving;
    bool m_bLogA4AF;
	bool m_bLogUlDlEvents;
// WebCache: ////////////////////////////////////////////////////////////////////////////////////
	bool m_bLogWebCacheEvents;//JP log webcache events
	bool m_bLogICHEvents;
/* new upnp disabled
	int		m_iLogUPnP;
*/
	bool m_bCreditSystem;
	bool m_bLog2Disk;
	bool m_bDebug2Disk;
	int m_iCommitFiles;
	bool m_bFilterLANIPs;
	bool m_bExtControls;
	UINT m_uServerKeepAliveTimeout;
	bool m_bSparsePartFiles;
	bool m_bCheckDiskspace;
	float m_fMinFreeDiskSpaceMB;
	CString m_sYourHostname;
	bool m_bFirewallStartup;
	int m_iLogLevel;
	bool m_bDisablePeerCache;
	bool m_bEnableACC; //Obelix
	//int m_iPawcioCredits; //Pawcio: Credits
	int m_iTimeUp; // Pawcio: BC
	int m_iTimeDown; // Pawcio: BC Download
	//Pawcio: BC removed
    bool m_bA4AFSaveCpu;
	int m_iExtractMetaData;

        // Morph: PowerShare
	int m_iPowershareMode; //MORPH - Added by [ionix], Avoid misusing of powersharing
	int m_iHideOS;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	bool m_bSelectiveShare;  //MORPH - Added by [ionix], SLUGFILLER: hideOS
	bool m_bShareOnlyTheNeed; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	int m_iPowerShareLimit; //MORPH - Added by [ionix], POWERSHARE Limit
        // <--- Morph: PowerShare
	bool m_bHighProcess; //MORPH - Added by IceCream, high process priority

	CSliderCtrl m_ctlFileBuffSize;
	CSliderCtrl m_ctlQueueSize;
    CTreeOptionsCtrlEx m_ctrlTreeOptions;
	bool m_bInitializedTreeOpts;
	HTREEITEM m_htiTCPGroup;
	HTREEITEM m_htiMaxCon5Sec;
	HTREEITEM m_htiMaxHalfOpen;
	HTREEITEM m_htiConditionalTCPAccept;
	HTREEITEM m_htiAutoTakeEd2kLinks;
	HTREEITEM m_htiVerboseGroup;
	HTREEITEM m_htiVerbose;
	HTREEITEM m_htiDebugSourceExchange;
	HTREEITEM m_htiLogBannedClients;
	HTREEITEM m_htiLogRatingDescReceived;
	HTREEITEM m_htiLogSecureIdent;
	HTREEITEM m_htiLogFilteredIPs;
	HTREEITEM m_htiLogFileSaving;
    HTREEITEM m_htiLogA4AF;
	HTREEITEM m_htiLogUlDlEvents;
	//HTREEITEM m_htiCreditSystem;
// WebCache: ////////////////////////////////////////////////////////////////////////////////////
	HTREEITEM m_htiLogWebCacheEvents; //jp log webcache events
	HTREEITEM m_htiLogICHEvents; 
/* new upnp disabled
	HTREEITEM	m_htiLogUPnP;
	// End -UPnPNAT Support-
*/
	HTREEITEM m_htiLog2Disk;
	HTREEITEM m_htiDebug2Disk;
	HTREEITEM m_htiCommit;
	HTREEITEM m_htiCommitNever;
	HTREEITEM m_htiCommitOnShutdown;
	HTREEITEM m_htiCommitAlways;
	HTREEITEM m_htiFilterLANIPs;
	HTREEITEM m_htiExtControls;
	HTREEITEM m_htiServerKeepAliveTimeout;
	HTREEITEM m_htiSparsePartFiles;
	HTREEITEM m_htiCheckDiskspace;
	HTREEITEM m_htiMinFreeDiskSpace;
	HTREEITEM m_htiYourHostname;
	// Removed by [ionix] [MoNKi: -Improved ICS-Firewall support-]
	/* Moved to PPgEmulespana
	HTREEITEM m_htiFirewallStartup;
	*/
	// End emulEspaa
	HTREEITEM m_htiLogLevel;
	HTREEITEM m_htiDisablePeerCache;
	HTREEITEM m_htiEnableACC; //Obelix
	//HTREEITEM m_htiPawcioCredits; //Pawcio: Credits
	HTREEITEM m_htiTimeUp; //Pawcio: BC
	HTREEITEM m_htiTimeDown; //Pawcio: BC Download
	//Pawcio: BC removed
	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo
	HTREEITEM m_htiBufferTimeLimit; // Buffer Time Limit - //
	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo

	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo
	int m_iBufferTimeLimit; // Buffer Time Limit - //
	//<<-- added by [ionix] - Buffer Time to Flush in Min. Limit - // xlillo

    HTREEITEM m_htiA4AFSaveCpu;
	HTREEITEM m_htiExtractMetaData;
	HTREEITEM m_htiExtractMetaDataNever;
	HTREEITEM m_htiExtractMetaDataID3Lib;
	//HTREEITEM m_htiExtractMetaDataMediaDet;

        // Morph: PowerShare
	HTREEITEM m_htiUM;
	HTREEITEM m_htiSFM;
	HTREEITEM m_htiPowershareMode;
	HTREEITEM m_htiPowershareDisabled;
	HTREEITEM m_htiPowershareActivated;
	HTREEITEM m_htiPowershareAuto;
	HTREEITEM m_htiPowershareLimited;
	HTREEITEM m_htiHideOS;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	HTREEITEM m_htiSelectiveShare; //MORPH - Added by [ionix], SLUGFILLER: hideOS
	HTREEITEM m_htiShareOnlyTheNeed; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	HTREEITEM m_htiPowerShareLimit; //MORPH - Added by [ionix], POWERSHARE Limit
        // <--- Morph: PowerSHare
	HTREEITEM m_htiHighProcess; //MORPH - Added by IceCream, high process priority


	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	virtual BOOL OnKillActive();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDestroy();
	afx_msg LRESULT OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam);
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
};
